#include "menu.h"
#include <stdio.h>
#include <stdlib.h>
#include "LCD4Bit_mod.h"

const char startText[]  = "Hauptmenu";
const char z1Text[] = "Menue1";
const char z2Text[] = "Menu2";
const char z3Text[] = "Menu3";
const char z4Text[] = "Startmeldung4";
const char errorText[] = "Startmeldung5";

extern LCD4Bit_mod lcd;

uint8_t nextstate(uint8_t s, uint8_t in){

  uint8_t s1;
  for(s1 = 0;s1< sizeof(transitions)/sizeof(transitions[0]);s1++){
     if ((pgm_read_byte(&transitions[s1].state)==s)&&(pgm_read_byte(&transitions[s1].input)==in))

       return (uint8_t)pgm_read_byte(&transitions[s1].nextState);
         }
  return s; //not found
}
STATE_INFO getStateInfo(uint8_t s){  //search for state info
  uint8_t s1;
  STATE_INFO si;
  for(s1 = 0;s1< sizeof(states)/sizeof(states[0]);s1++){
     if ((pgm_read_byte(&states[s1].state)==s)){

        si.state = s;
        si.text = (PGM_P) pgm_read_word(&states[s1].text);
        si.p = (char (*)(char)) pgm_read_word(&states[s1].p);
        return si;
     }

  }
  si.state = ERROR;  //nothing found
  si.text = "";
  si.p = NULL;
  return si;
}


char test1(char s){
   lcd.printIn("test1");
  return 'c';
}
char test2(char s){
  lcd.printIn("test2");
  return 'h';
}

void stateAction(uint8_t state){
   char buf[20];
   STATE_INFO si = getStateInfo(state);
   strcpy_P(buf, si.text);
   lcd.clear();
   if (si.text != NULL) lcd.printIn(buf);
   if (si.p != NULL) si.p(0);  //call state action
   //Serial.println(buf);
}
